//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <set>
#include <deque>
#include <algorithm>
#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}

int main(int argc, char* argv[])
{
  set<int,greater<int> > coll1; 
  deque<int> coll2;

  //      1  9 
  for (int i=1; i<=9; ++i) { 
    coll1.insert(i);
  }

  PRINT_ELEMENTS(coll1,":\n");

  //    coll2   10
  transform (coll1.begin(),coll1.end(), // 
    back_inserter(coll2),               // 
    bind2nd(multiplies<int>(),10));     // 
  PRINT_ELEMENTS(coll2," :\n");

  //  ,  70,  42
  replace_if (coll2.begin(),coll2.end(), // 
    bind2nd(equal_to<int>(),70),         //  
    42);                                 //  
  PRINT_ELEMENTS(coll2," :\n");

  //     ,  50
  coll2.erase(remove_if(coll2.begin(),coll2.end(), // 
    bind2nd(less<int>(),50)),                      //  
    coll2.end());
  PRINT_ELEMENTS(coll2," :\n");

  cout << endl;

  getch();
  return 0;
}
//---------------------------------------------------------------------------
